#pragma once

#include <QObject>


enum EErrorPriority
{
	PRIORITY_INFO,
	PRIORITY_WARNING,
	PRIORITY_ERROR,
	PRIORITY_DEBUG
};

class CErrorHandling
: public QObject
{
	Q_OBJECT
private:
		CErrorHandling(); //no instance of this class allowed, so contructor is private
public:

	static void Error(QString message, EErrorPriority priority);
	static CErrorHandling* GetErrorObject();

signals:
	void ErrorProcessed(const QString& error,int timeout);

private:
	static CErrorHandling*	s_errorObj;
	static QString			s_error;
};


//Use this Macros for error message displaying
#define		SHOW_ERROR(message)		CErrorHandling::Error(message, PRIORITY_ERROR)
#define		SHOW_WARNING(message)	CErrorHandling::Error(message, PRIORITY_WARNING)
#define		SHOW_INFO(message)		CErrorHandling::Error(message, PRIORITY_INFO)
