#pragma once

#include <QtGui>
#include "IOWidget\IOWidget.h"
#include "PatternWidget\PatternWidget.h"
#include "USBCommunication\IOExpanderCommunicationModule.h"
#include "SPIWidget\SPIWidget.h"
#include "ServoWidget\ServoWidget.h"
#include "IOExpanderWidget.h"

class CIOExpanderCentralWidget : public QWidget
{
	Q_OBJECT
public:
	CIOExpanderCentralWidget( CIOExpanderCommunicationModule & commModule );
	~CIOExpanderCentralWidget();
	void setPage(int index);
	void showPaneel(int show);

signals:
	void pageSelected(int n);

private slots:
	void changePage(QListWidgetItem *current, QListWidgetItem *previous);

private:
	void	SetupLayout();
	void	SetupSignals();
	void	CreateIcons();

	QListWidget				*m_contentsWidget;
	QStackedWidget			*m_pagesWidget;

	CIOWidget		*m_ioControlTab;
	CPatternWidget	*m_patternTab;
	CSPIWidget		*m_spiTab;
	CServoWidget	*m_servoTab;

	CIOExpanderCommunicationModule	&m_commModule;
};
