#pragma once

#include <QtGui>
#include <QList>


#include "IOExpanderCentralWidget.h"
#include "USBCommunication/IOExpanderCommunicationModule.h"
#include "IOExpanderStatusBar.h"
#include "IOExpanderWidget.h"

class CIOExpanderMainWindow
:public QMainWindow
{
	Q_OBJECT;
public:
	CIOExpanderMainWindow();

	void setupLayout();
	void setupSignals();
	void setupMenu();
	void setupShortCuts();

private slots:
	void viewMenuChanged ( QAction * action );
	void showPaneel(bool);
	void updateViewCheckboxes(int n);

	void showAboutMessage();
	void showShortcutsMessage();
	void showSoftwareVersion();

	void saveSoftwareVersion(QString sw);
	void connectionLost();

protected:
	void closeEvent(QCloseEvent *event);
private:
	CIOExpanderCentralWidget		*m_centralWidget;
	CIOExpanderCommunicationModule	*m_commModule;
	CIOExpanderStatusBar					*m_statusBar;

	QMenu	*m_fileMenu;
	QMenu	*m_viewMenu;
	QMenu	*m_helpMenu;

	QAction	*m_showPaneelAction;

	QList<QAction*>	m_viewActions;
	QActionGroup	*m_viewActionGroup;

	QString			m_softwareVer;

	QShortcut	*	m_togglePaneelShortCut;
	QList<QShortcut*>	m_quickSelectShortCuts;
};
