#include "PatternDefinitionWindow.h"
#include "../ErrorHandling.h"

CPatternDefinitionWindow::CPatternDefinitionWindow(QWidget * parent)
:QDialog(parent,Qt::WindowTitleHint | Qt::WindowSystemMenuHint)
{
	SetupLayout();
	SetupSignals();
}

CPatternDefinitionWindow::~CPatternDefinitionWindow()
{

}

void CPatternDefinitionWindow::SetupLayout()
{
	m_okCancelButtons = new QDialogButtonBox( QDialogButtonBox::Ok /*| QDialogButtonBox::Cancel */);

//	QGroupBox * patternBox = new QGroupBox("Output-Pattern");
//	QGroupBox * controlBox = new QGroupBox("Steuerung");

	QGridLayout	*layout = new QGridLayout(this);
//	QGridLayout *patternLayout = new QGridLayout;

	QRegExp	rx("[0-1]{,200}");
	QRegExpValidator	*v = new QRegExpValidator(rx,0);

	for(int n = 0; n < 16; n++)
	{
		QLabel	*label = new QLabel(tr("Bit") + QString::number(n));
		m_edits[n] = new QLineEdit;
		m_edits[n]->setMinimumWidth(500);
		m_edits[n]->setValidator(v);

		QString str;
		for(int i = 0; i < m_pattern[n].size();i++)
		{
			if(m_pattern[n].testBit(i))
				str += tr("1");
			else
				str += tr("0");
		}
		m_edits[n]->setText(str);

		layout->addWidget(label,n,0);
		layout->addWidget(m_edits[n],n,1);
	}
	layout->addWidget(m_okCancelButtons,16,0,1,2);
	setLayout(layout);
}

void CPatternDefinitionWindow::SetupSignals()
{
	connect(m_okCancelButtons, SIGNAL(accepted()), this, SLOT(accept()));
    connect(m_okCancelButtons, SIGNAL(rejected()), this, SLOT(reject()));
}

QBitArray * CPatternDefinitionWindow::GetPattern()
{
	int maxSize = 0;
	QString str[16];

	for(int n = 0; n < 16;n++)
	{
		str[n] = m_edits[n]->text();
		maxSize = str[n].length() > maxSize ? str[n].length() : maxSize;
	}
	if(maxSize == 0)
		return 0;

	for(int n = 0; n < 16;n++)
	{
		m_pattern[n].clear();
		m_pattern[n].fill(0,maxSize);

		for(int i = 0; i < str[n].length();i++)
		{
			m_pattern[n].setBit(i, str[n].at(i) == '1' ? 1 : 0);
		}
	}

	return m_pattern;
}
