#pragma once

#include <QtGui>
#include <QBitArray>

#include "PatternViewWidget.h"
#include "PatternDefinitionWindow.h"
#include "TriggerDefinitionWindow.h"
#include "../IOExpanderWidget.h"

class CPatternWidget
: public CIOExpanderWidget
{
Q_OBJECT

public:
	CPatternWidget();
	~CPatternWidget();

	void ShowWidgetCallback();
	void HideWidgetCallback();
	void CloseWidgetCallback();

signals:
// Interfaces to the USB comm module
	void RequestSamples(quint8 num, quint16 frequ, quint16 trigger1, quint16 trigger2);
	void SendPattern(QBitArray *pattern, quint16 frequ, quint16 trigger1, quint16 trigger2);
	void RequestSamplesAndSendPattern(QBitArray *pattern, quint16 frequ, quint16 trigger1, quint16 trigger2);

public slots:
//new input pattern were received
	void UpdateInputSamples(QBitArray *pattern);

private slots:
//buttons
	void RequestButton();
	void DefineOutputPatternButton();
	void DefineTriggerButton();
	void SelectOutput(bool);
	void SavePatternToDisk();
	void LoadPatternFromDisk();

private:
	void SetupLayout();
	void SetupSignals();

private:
	CPatternViewWidget		*m_pattern;
	CPatternDefinitionWindow	*m_defDialog;
	QPushButton			*m_defineOutputPatternButton;
	CTriggerDefinitionWindow	*m_trigDefDialog;
	QPushButton			*m_defineTriggerButton;
	QPushButton			*m_requestButton;
	QPushButton			*m_saveButton;
	QPushButton			*m_loadButton;
	QSpinBox			*m_numSamplesSpinBox;
	QSpinBox			*m_frequencySpinBox;
	QCheckBox			*m_useInputCheckBox;
	QCheckBox			*m_useOutputCheckBox;
	QLabel				*m_numSamplesLabel;

private:
	QBitArray			m_inputPattern[16];
	QBitArray			m_outputPattern[16];
	quint16				m_trigger1;
	quint16				m_trigger2;
};
