#pragma once

#include <QtGui>
#include <QBitArray>
#include <QString>
#include <QRectF>

enum EPatternType	{PATTERN_IN,PATTERN_OUT,PATTERN_UNDEFINED};

class CSinglePattern
: public QGraphicsItem
{
public:
	CSinglePattern();
	CSinglePattern(QBitArray p, int id, EPatternType type);
	~CSinglePattern();

	void paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *);

	void	BuildPattern(QBitArray	p);
	bool	Type();
	QRectF boundingRect () const;
private:
	QPen			m_pen;
	QPainterPath*	m_patternShape;
	QBitArray		m_pattern;
	int				m_id;
	EPatternType	m_type;

public:
	const static	int		s_dataPointHeight;
	const static	int		s_dataPointWidth;
	const static 	int		s_borderSize;
	const static 	int 	s_patternHeight;
};
