#include <QtGui>
#include <QList>
#include <QRegExpValidator>

#include "../IOExpanderWidget.h"

class CSPIWidget
: public CIOExpanderWidget
{
Q_OBJECT
public:
	CSPIWidget();
	~CSPIWidget();

	void ShowWidgetCallback();
	void HideWidgetCallback();
	void CloseWidgetCallback();

public slots:
	void	SpiDataReceived(quint8 data);

signals:
	void 	SendSPIData(quint8 spcr, quint8 spsr, QList<quint8> data);

private slots:
	void	SendDataButtonPressed();
	void	DataModeChangeButtonPressed(int id);

private:
	void	SetupLayout();
	void	SetupSignals();

	void	GetConfigFromGui(quint8 &spcr, quint8 &spsr);

private:
	QButtonGroup	*m_dataOrderConfigGroup; //lsb first, msb first
	QButtonGroup	*m_clockPolConfigGroup; //rising, falling edge
	QButtonGroup	*m_clockPhaseConfigGroup; //rising, falling edge
	QButtonGroup	*m_clockRateConfigGroup; //8
	QButtonGroup	*m_setDataModeGroup;
	QLineEdit		*m_txDataEdit;
	QLineEdit		*m_rxDataEdit;
	QPushButton		*m_sendDataButton;

	QRegExpValidator	*m_dataValidator;
	int				m_base;
};
