#pragma once

#include <QtGui>
#include <QtGlobal>
#include <QString>

#include "../IOExpanderWidget.h"


class CServoWidget
:public CIOExpanderWidget
{
Q_OBJECT;
public:
	CServoWidget();

	void ShowWidgetCallback();
	void HideWidgetCallback();
	void CloseWidgetCallback();

private:
	void setupLayout();
	void setupSignals();
	QList<float> getServoValuesFromGui();

private slots:
	void autoSetCheckBoxToggled(bool);
	void invCheckBoxToggled(bool);
	void emitSendServoSignal();

signals:
	void setServos(QList<float> values,float min,float max);
	void setOutput(quint16);

private:
	QDial		*m_dials[8];
	QCheckBox	*m_invCheckboxes[8];

	QPushButton	*m_setServosButton;
	QCheckBox	*m_autoSetServosCheckbox;
	QDoubleSpinBox	*m_minPulseBox;
	QDoubleSpinBox	*m_maxPulseBox;
	QTimer		*m_pollServoTimer;
};
