#include "USBCommand.h"


CUSBCommand::CUSBCommand(char cmd, bool interruptable)
{
	m_cmd = cmd;
	m_data << cmd;
	m_interruptable = interruptable;
	m_answerBytes = 0;
}

void CUSBCommand::appendData(quint8 d)
{
	m_data << d;
}

void CUSBCommand::operator<<(quint8 d)
{
	appendData(d);
}

void CUSBCommand::setAnswerBytes(quint16 n)
{
	m_answerBytes = n;
}

QList<quint8>	CUSBCommand::Answer()
{
	return m_answer;
}

char CUSBCommand::Cmd()
{
	return m_cmd;
}

void CUSBCommand::setCfgData(QList<quint8> cfg)
{
	m_cfgData = cfg;
}

void CUSBCommand::setCfgData(quint8 cfg)
{
	m_cfgData.clear();
	m_cfgData << cfg;
}

QList<quint8> CUSBCommand::getCfgData()
{
	return m_cfgData;
}
