#pragma once


//include this, if compiling on windows
#if defined(__WIN32__) || defined(__CYGWIN__)
#include <windows.h>
#endif

#include "FTD2XX.H"
#include "USBCommand.h"

#include <QThread>
#include <QTimer>
#include <QList>



class CUSBCommunicationModule
:public QThread
{
	Q_OBJECT
public:
	//Open device by name
	CUSBCommunicationModule(const QString &device, int pollIntervall = 10);

signals:
	void 	ConnectionLost();
	void 	ConnectionEstablished();

public:
	bool	IsConnected();
	void 	SendCommand(CUSBCommand cmd);

private:
	void 	run(); //the thread
	void 	OpenUSBDevice();
	void 	CloseUSBDevice();

protected:
	virtual void	ProcessReceivedData(CUSBCommand cmd) = 0;
	virtual void 	ConnectionEstablishedCallback()=0;

private slots:
	void 	PollUSB();

private:
	bool		m_open;
	FT_HANDLE	m_handle;
	int			m_pollIntervall;
	QString		m_deviceName;

	QList<CUSBCommand>	m_commands;
};
